package Bot;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class SnakeBot extends Bot {

    public SnakeBot(String[] args) {
        super(args);
    }

    int counter=0;

    @Override
    protected char nextMove(View view) throws IOException {
        int wagenIndex = view.data.indexOf("*");

        // Berechne die x- und y-Koordinaten der "0" im Sichtfeld
        int wagenX = wagenIndex % view.width;
        int wagenY = wagenIndex / view.width;
        //Berechen die x- und y-Koordinate der @ im Sichtfeld


        // Berechne die x- und y-Koordinaten der aktuellen Position des Bots
        int botX = view.width / 2;
        int botY = view.width / 2;

        System.out.println("wagen"+wagenX+" ,"+wagenY);
        System.out.println("bot"+botX+", "+botY);
    if((wagenY+1)==botY){
        System.out.println("ich dreh mich ");
        return '>';
    }else {
        return search(view);
    }

    }

private char search(View view){


        if(view.data.contains("@")){
            return moveToRocket(view);
        }
        else {
            System.out.println("ich laufe");
            counter++;
            if(counter>40){
                counter=0;
                return '>';
            }
            return '^';
        }
}


    private char moveToRocket(View view) {

        int wagenIndex = view.data.indexOf("*");

        // Berechne die x- und y-Koordinaten der "0" im Sichtfeld
        int wagenX = wagenIndex % view.width;
        int wagenY = wagenIndex / view.width;


        int botX = view.width / 2;
        int botY = view.width / 2;

        // Finde alle '@'-Symbole im Sichtfeld
        List<Integer> targetIndices = new ArrayList<>();
        for (int i = 0; i < view.data.length(); i++) {
            if (view.data.charAt(i) == '@') {
                targetIndices.add(i);
            }
        }

        if (targetIndices.isEmpty()) {
            // Keine Ziele vorhanden, laufe weiter
            System.out.println("Ich laufe weiter");
            return '^';
        }

        // Finde das am nächsten liegende Ziel
        int nearestTargetIndex = findNearestTarget(botX, botY, targetIndices, view.width);

        // Berechne die x- und y-Koordinaten des nächsten Ziels
        int targetX = nearestTargetIndex % view.width;
        int targetY = nearestTargetIndex / view.width;

        // Bewege dich in Richtung des nächsten Ziels
        if (targetY < botY) {
            System.out.println("Ich bewege mich nach oben");
            return '^';
        } else if (targetY > botY) {
            if((wagenY+1)==botY){
                System.out.println("ich dreh mich ");
                return '>';
            }else {


            System.out.println("Ich bewege mich nach unten");
            return 'v';}
        } else {
            if (targetX < botX) {
                System.out.println("Ich drehe mich nach links");
                return '<';
            } else if (targetX > botX) {
                System.out.println("Ich drehe mich nach rechts");
                return '>';
            }
        }

        // Default-Rückgabewert, sollte nicht erreicht werden
        return 'q';
    }

    private int findNearestTarget(int botX, int botY, List<Integer> targetIndices, int width) {
        int nearestTargetIndex = -1;
        int minDistance = Integer.MAX_VALUE;

        for (int targetIndex : targetIndices) {
            int targetX = targetIndex % width;
            int targetY = targetIndex / width;

            int distance = Math.abs(targetX - botX) + Math.abs(targetY - botY);

            if (distance < minDistance) {
                minDistance = distance;
                nearestTargetIndex = targetIndex;
            }
        }

        return nearestTargetIndex;
    }

    public static void main(String[] args) {
        SnakeBot snakebot= new SnakeBot(args);
        snakebot.run();
    }
}
