package Praktikum4;

import java.io.*;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Scanner;

public class SorterClient {

    public static void main(String[] args) {
        SorterClient client = new SorterClient();
        client.run();
    }

    private void run() {
        Scanner scanner = new Scanner(System.in);
        while (scanner.hasNextLine()) {
            String line = scanner.nextLine();
            if (line.isEmpty())
                break;
            line = sort(line);
            System.out.println(line);
        }
        scanner.close();
    }

    private static final String SERVER_ADDRESS = "localhost";
    private static final int SERVER_PORT = 12345;

    private String sort(String line)
    {

        InetSocketAddress adress = new InetSocketAddress(SERVER_ADDRESS, SERVER_PORT);
        try ( Socket socket = new Socket()) {
            socket.connect(adress);
            sendLine(socket, line);
            String answer = receiveLine(socket);
          return answer;
        } catch (IOException e) {
            e.printStackTrace();
            return "Error: Unable to communicate with the server.";
        }
    }

    public static String receiveLine(Socket socket) throws IOException {
        InputStream in = socket.getInputStream();
        BufferedReader reader = new BufferedReader(new InputStreamReader(in));
        return reader.readLine();
    }

    public static void sendLine(Socket socket, String line) throws IOException {
        OutputStream out = socket.getOutputStream();
        PrintWriter writer = new PrintWriter(out);
        writer.println(line);
        writer.flush();
    }
}
